#include "client_server_interact.h"
#include <engine_engine_number_9/form_data_structure/urlencoded_query.h>
#include <engine_engine_number_9/baza_throw.h>
#include "../str_fields.h"

namespace iu9cawebchat {
    std::string when_page_login(WorkerGuestData& wgd, const json::JSON& config_presentation,
        const een9::ClientRequest& req, const std::vector<LoginCookie>& login_cookies, const json::JSON& userinfo) {
        if (req.method == "POST") {
            std::vector<std::pair<std::string, std::string>> query = een9::split_html_query(req.body);
            int64_t uid = -1;
            std::string nickname;
            std::string password;
            try {
                for (const std::pair<std::string, std::string>& cmp: query) {
                    if (cmp.first == "nickname")
                        nickname = cmp.second;
                    if (cmp.first == "password")
                        password = cmp.second;
                }
                een9_ASSERT(check_nickname(nickname), "/login/accpet-data rejected impossible nickname");
                een9_ASSERT(check_password(password), "/login/accpet-data rejected impossible password");
                uid = find_user_by_credentials(*wgd.db, nickname, password);

            } catch(const std::exception& e){}
            if (uid < 0) {
                printf("Redirecting back to /login because of incorrect credentials\n");
                /* todo: Here I need to tell somehow to user (through fancy red box, maybe), that login was incorrect */
                return RTEE("login", config_presentation, wgd, userinfo);
            }
            std::vector<std::pair<std::string, std::string>> response_hlines;
            LoginCookie new_login_cookie = create_login_cookie(nickname, password);
            add_set_cookie_headers_to_login(login_cookies, response_hlines, new_login_cookie);
            return een9::form_http_server_response_303_spec_head("/", response_hlines);
        }
        return RTEE("login", config_presentation, wgd, userinfo);
    }
}
